class ProviderStatusesController < ApplicationController
  layout 'test' if MagicNumber['test_layout']
  before_filter :authenticate_admin!, :only => [:index, :show, :edit, :update, :destroy]

  def index
    @page = ProviderStatus.page params[:page]
    @page_size = ProviderStatus.page_size params[:page_size]
    @hide = params[:hide]
    @provider_statuses = if @hide.blank?
      ProviderStatus.list(@page, @page_size)
    else
      ProviderStatus.available_list(@page, @page_size)
    end

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @provider_statuses.to_json(ProviderStatus.list_json_opt) }
    end
  end

  def show
    @provider_status = ProviderStatus.show(params[:id], @admin)

    respond_to do |format|
      format.html # show.html.erb
      format.json { render :json => @provider_status.to_json(ProviderStatus.show_json_opt) }
    end
  end

  def edit
    @provider_status = ProviderStatus.edit(params[:id], @admin)
    respond_to do |format|
      format.html 
      format.js
    end
  end

  def update
    @provider_status = ProviderStatus.edit(params[:id], @admin)
    @provider_status.attributes = params[:provider_status]
    @provider_status.overwrite
    respond_to do |format|
      if @provider_status.save
        format.html { redirect_to @provider_status, notice: 'ProviderStatus was successfully updated.' }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @provider_status.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @provider_status = ProviderStatus.edit(params[:id], @admin)
    @provider_status.destroy
    respond_to do |format|
      format.html { redirect_to comics_url }
      format.json { head :ok }
    end
  end
end
